#include <stdio.h>
#include <math.h>
#define BYTE    unsigned char    
#define thr       99              // ~99  black_white threshold
#define scale     0.2             // work_area/whole_pic of X,Y 
#define ms        15              // search slope: +-ms degree
#define nn  3500*2500             // now is 3439*2439, iW*iH
BYTE a[nn*3];                     // pcImg:      raw pic
BYTE b[nn*3];                     // pcDestImg:  Dest_memory
int  iColorType,iW,iH;            // color 3; grey 1; width,height
short h[539];                     // BMP header
BYTE *p0,*p1,*p2,*p3;             // array pointer.
double a1,a2,a3,a4,a5,a6;         // 6 transfer parms
double slope;                     // we just wanted !
int t[1000],s[ms+ms+1],it;        // temp;  print more ?

int  WORK(BYTE *pcImg,BYTE *pcDest,float av2,float av3);
int  bmp2raw(char *f1,BYTE *pcImg);
void raw2bmp(char *f2,BYTE *pcDest);

main(int ac,char **av)
{
  char f1[22],f2[24]; int i;
  float av2,av3;                    // work area center
  if(ac<2){ printf("\n\t ****** slope a pic of BMP(16m/256) *******\n");
            printf("\n\t                       jiang, 2013,9,11\n");
            printf("\n\t sl10 in[.bmp] [X Y !]");
            printf("\n\t Usage: sl10 m2_2");
            printf("\n\t set output bmp file:  s_in.bmp");
            printf("\n\t X,Y: work_point (small area center");
            printf("\n\t      0, 0  auto select");
            printf("\n\t      0.5 0.5 ( 0.1~0.9)");
            printf("\n\t      X_pixel Y_pixel");
            printf("\n\t ! means: print more\n\n");
            return(0); }
  it=(ac>4)?1:0; strcpy(f1,av[1]);
  for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0; strcat(f1,".bmp");
  av2=av3=0.; if(ac>3){ sscanf(av[2],"%f",&av2); sscanf(av[3],"%f",&av3); }

  i=bmp2raw(f1,a);
  if(i==1){ printf("\n\t%s not found!\n",f1); return(0); }

  i=WORK(a,b,av2,av3);         // pcImg ==>  pcDestImag

  if(i==2)printf("\n\tfail: defined area no messages\n",f1); 
  if(i==0){ sprintf(f2,"s_%s",f1); printf(" ok ! outfile: %s\n",f2);
    raw2bmp(f2,b);
  }
  return(0);
}

int bmp2raw(char *f1,BYTE *pcImg)
{
  int i,j,k; FILE *fp; 
  fp=fopen(f1,"rb"); if(!fp)return(1); printf("%s ==> ",f1);
  fread(h,2,27,fp);  iColorType=h[14]/8;  iW=h[9]; iH=h[11]; 
  if(it)printf("iW:%6d\tiH:%6d\tcolor: %d\n",iW,iH,iColorType);
  if(iColorType==3){   k=(4-3*iW%4)%4+3*iW;
    p1=(BYTE *)pcImg; p2=(BYTE *)p1+iW*iH; p3=(BYTE *)p2+iW*iH;
    for(j=0;j<iH;j++){ fread(b,1,k,fp); p0=(BYTE *)b;
      for(i=0;i<iW;i++){ *p1++=*p0++; *p2++=*p0++; *p3++=*p0++; }
    }   
  } else {             k=(4-iW%4)%4+iW;
    fread(&h[27],2,512,fp);
    for(j=0;j<iH;j++){ p1=(BYTE *)pcImg+j*iW; fread(p1,1,k,fp); }
  } fclose(fp);
  return(0);
}

int WORK(BYTE *a,BYTE *b,float av2,float av3)
{
  int i,j,k,m, ixc,iyc, iw2,ih2,ih, iturn=0,ss,mm;
  float x,y;
  ixc=iW/2; iyc=iH/2;
  if(av2!=0.){ if(av2<1.)ixc=av2*iW; else if(av2<iW)ixc=av2; } 
  if(av3!=0.){ if(av3<1.)iyc=av3*iH; else if(av3<iH)iyc=av3; } 

  iw2=scale*iW/2;  ih2=scale*iH/2; if(ih2>500)ih2=500;  ih=ih2*2;
l10: 
  if(ixc<iw2)ixc=iw2; if(ixc+iw2>iW-1)ixc=iW-iw2-1;
  if(iyc<ih2)iyc=ih2; if(iyc+ih2>iH-1)iyc=iH-ih2-1;
  if(it)printf("ixc,iyc: %d %d\n",ixc,iyc);

  k=(iyc-ih2)*iW; 
  for(j=0;j<ih;j++){ t[j]=0;
    for(i=ixc-iw2;i<ixc+iw2;i++)if(a[k+i]<thr)t[j]++; k+=iW; 
  }
  if(iturn==0){ iturn=1;                 // iyc auto adjust
    for(j=0;j<ih;j++)if(t[j])break;
    if(j==ih)return(2);
    if(j>20){ iyc+=j; printf("iyc adjusted! %d --> %d\n",iyc-j,iyc); goto l10; }
    for(j=ih-1;j>=0;j--)if(t[j])break;
    if(j<ih-20){iyc-=j;printf("iyc adjusted %d --> %d!\n",iyc+j,iyc);goto l10; }
  }

  ss=-ms; mm=0;
  for(iturn=-ms;iturn<=ms;iturn++){
    turn0(a,b,ixc,iyc,iw2,ih2, iturn*1.); 
    k=(iyc-ih2)*iW; m=0;
    for(j=0;j<ih;j++){ t[j]=0;
      for(i=ixc-iw2;i<ixc+iw2;i++)if(b[k+i]<thr)t[j]++;
      k+=iW; if(t[j]==0)m++;
    } s[iturn+ms]=m;
    if(it)printf("%3d_%3d\n",iturn,m);
    if(m<mm*3/4 && mm>50)break;
    if(m>mm){ mm=m; ss=iturn; }
  } k=ss+ms;
  paowu(s[k-1],s[k],s[k+1],&x);
  slope=x+ss;
  if(it)printf("%d_%d %d_%d %d_%d",ss-1,s[k-1],ss,s[k],ss+1,s[k+1]);
  printf("  slope: %6.2lf (degree)",slope);

  turn1(a,b);                   // real transfer !
  return(0);
}

turn1(BYTE *a,BYTE *b)                  // a ===(slope)===> b
{
  int i,j,k, ix,iy,u,v;
  double cosa,sina,z;
  float x,y, wx,wy,ux,uy, z0,z1,z2,z3;
  z=slope*3.1416/180.;
  cosa=cos(z); sina=sin(z);
  a1=a4=cosa; a2=sina;  a3=-a2; a5=iW*.5; a6=iH*.5;
  for(k=0;k<iColorType;k++){
    p1=(BYTE *)b+iW*iH*k; p0=(BYTE *)a+iW*iH*k;
    for(j=0;j<iH;j++)for(i=0;i<iW;i++){
      x=a1*(i-a5)+a3*(j-a6)+a5;
      y=a2*(i-a5)+a4*(j-a6)+a6;
      ix=x; wx=x-ix; ux=1.-wx; iy=y; wy=y-iy; uy=1.-wy;
      if(ix<0 || ix>=iW-2 || iy<0 || iy >=iH-2){ *p1++=255; continue; }
      u=iW*iy+ix; v=u+iW;
      if(u>=0 && v<iW*iH-1){
        z0=ux*uy; z1=wx*uy; z2=ux*wy; z3=wx*wy;
        *p1++=p0[u]*z0+p0[u+1]*z1+p0[v]*z2+p0[v+1]*z3;
      } else *p1++=255;
    }
  }
}

paowu(int y1,int y2,int y3,float *x){ *x=(y1-y3)/(0.5*(y1+y3)-y2)*0.25; }

turn0(a,b,ixc,iyc,iw2,ih2,sl)
BYTE *a,*b; int ixc,iyc,iw2,ih2; float sl;
{
  int i,j,k, ii,jj;
  double cosa,sina,z;
  z=sl*3.1416/180.;
  cosa=cos(z); sina=sin(z);
  a1=a4=cosa; a2=sina;  a3=-a2; a5=ixc; a6=iyc;
  for(j=iyc-ih2;j<iyc+ih2;j++)for(i=ixc-iw2;i<ixc+iw2;i++){
    ii=(i-a5)*a1+(j-a6)*a3+a5;
    jj=(i-a5)*a2+(j-a6)*a4+a6;
    b[j*iW+i]=a[jj*iW+ii];
  }
}

void raw2bmp(char *f2,BYTE *pcDest)
{
  int i,j,k;  FILE *fp; 
  fp=fopen(f2,"wb");
  if(iColorType==1){ k=(4-iW%4)%4+iW;
    fwrite(h,2,539,fp);
    for(j=0;j<iH;j++){ p1=(BYTE *)pcDest+j*iW; fwrite(p1,1,k,fp); }
  } else {           k=(4-3*iW%4)%4+3*iW;
    fwrite(h,2,27,fp);
    p1=(BYTE *)pcDest; p2=(BYTE *)p1+iW*iH; p3=(BYTE *)p2+iW*iH;
    for(j=0;j<iH;j++){   p0=(BYTE *)a;
      for(i=0;i<iW;i++){ *p0++=*p1++; *p0++=*p2++; *p0++=*p3++; }
      fwrite(a,1,k,fp);
    }
  } fclose(fp);
}
/*
tofit(f1,a,n1,n2)
char *f1; BYTE *a; int n1,n2;
{
  int i,j; FILE *fp; char head[36][80];
  for(j=0;j<36;j++)for(i=0;i<80;i++)head[j][i]=32;
  sprintf(head[ 0],"SIMPLE  =                    T /");
  sprintf(head[ 1],"BITPIX  =                    8 /");
  sprintf(head[ 2],"NAXIS   =                    2 /");
  sprintf(head[ 3],"NAXIS1  =                 %4d /",n1);
  sprintf(head[ 4],"NAXIS2  =                 %4d /",n2);
  sprintf(head[35],"END                             ");
  for(j=0;j<36;j++)head[j][32]=32;
  fp=fopen(f1,"wb");  fwrite(head,36,80,fp);
  fwrite(a,n1,n2,fp); fclose(fp);
  printf("%s produced !\n",f1);
}
*/
